#ifndef _STRINGS_H
#define _STRINGS_H

#include <stddef.h>

#ifdef __cplusplus
extern "C"
{
#endif

    /* Clears n bytes of buf. */
    void bzero(void* buf, size_t n);

    /* Copies n bytes of src into dest. */
    void bcopy(void* dest, const void* src, size_t n);

    /* Compares strings a and b while treating uppercase and lowercase characters as the same. */
    int strcasecmp(const char* a, const char* b);

    /* Compares at most max bytes of strings a and b while treating uppercase and lowercase characters as the same. */
    int strncasecmp(const char* a, const char* b, size_t max);

#ifdef __cplusplus
}
#endif

#endif